︠68650b4d-b3bf-4782-b371-9e74ad802a69︠
#    First, create a "first head" random variable, which simulates flipping a coin until it is heads,
#    and records which flip is the first head.


def first_head():
    coin=0    # 0 for tails, 1 for heads.  Start by setting the coin to tails
    count=0   # Keep track of the number of flips before first head 
    while coin == 0:    # the two lines in this "while loop" will be executed as long as the coin value is 0
                        # but once it equals 1, the loop ends and we move to the final line of the function def.
        coin=randint(0,1)    # set coin equal to 0 or 1 randomly
        count += 1           # increment the count
    return count             # this is the count value when the coin first equals 1 (and thus, the while loop ends).
    
# test a few outputs and compute the average payoff (which, theoretically, is INFINITE).
sum=0
nTrials=10
for _ in range(nTrials):
    fh = first_head()
    print('First head at flip # %s.  You win %s dollars!'%(fh, 2^fh))
    sum += 2^fh
print('Average payoff was %s.' %float(sum/nTrials))
︡6885e989-1738-4168-98df-d2fee5f5de8a︡{"stdout": "First head at flip # 1.  You win 2 dollars!\nFirst head at flip # 2.  You win 4 dollars!\nFirst head at flip # 3.  You win 8 dollars!\nFirst head at flip # 5.  You win 32 dollars!\nFirst head at flip # 1.  You win 2 dollars!\nFirst head at flip # 3.  You win 8 dollars!\nFirst head at flip # 1.  You win 2 dollars!\nFirst head at flip # 1.  You win 2 dollars!\nFirst head at flip # 5.  You win 32 dollars!\nFirst head at flip # 3.  You win 8 dollars!\nAverage payoff was 10.0."}︡
︠2da55852-386a-4d32-9cce-cbab91872bf2︠
################################################################################
#    Here is one simulation of playing 1000 games, where the price to play each
#    game is 5 dollars.  The result is a plot of the money on hand after each play,
#    using the list_plot function.
################################################################################    

price = 5    #cost to play the game once
nGames = 1000
accumulation = 0    #player's profit
sequence = []       #keep track of the first_head() outputs
daily = []          #accumlation on each day; to be built
for _ in range(nGames):
    fh = first_head()
    sequence.append(fh)
    accumulation += 2^fh-price
    daily.append(accumulation)
    
list_plot(daily,plotjoined = True)
︡3d49944e-e5b4-4adb-872d-7a839cfbceec︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠4e1748b7-b1f8-412b-bc7c-ded890831772︠
#########################################################################################
#    This is an INTERACTIVE simulation which allows you to change the price per game
#    and the total number of games.  It also prints out the maximum payout, and 
#    when this happened, the final amount of money on hand, the minimum amount, and the maximum,
#    and the average payout (which, theoretically, is INFINITY). 
#    
#    Note the use of the @interactive command, followed by a function definition (the
#    name of the function can be anything, but we choose the generic "_" since we will never use the 
#    function's name.  You can look up the use of Sage interactive online, or just study this example.
#    It's pretty flexible, and easier to use than Mathematica's Manipulate command, although less slick.
##############################################################################################

# We include the already-defined first_head function, so that this is a stand-alone cell.

def first_head():
    coin=0    # 0 for tails, 1 for heads.  Start by setting the coin to tails
    count=0   # Keep track of the number of flips before first head 
    while coin == 0:    # the two lines in this "while loop" will be executed as long as the coin value is 0
                        # but once it equals 1, the loop ends and we move to the final line of the function def.
        coin = randint(0,1)    # set coin equal to 0 or 1 randomly
        count += 1           # increment the count
    return count             # this is the count value when the coin first equals 1 (and thus, the while loop ends).
 
 
 
    
############################################################################################################
#    interactive part starts here
############################################################################################################

@interact
def _(price= [5,10,15,20], nGames = [100,1000,10000,100000]):
    # note that the selection boxes for price and nGames are defined in the function defn above.
    accumulation = 0    #player's profit
    sequence = []       #keep track of the first_head() outputs
    daily = []          #accumlation on each day; to be built
    for _ in range(nGames):
        fh = first_head()
        sequence.append(fh)
        accumulation += 2^fh-price
        daily.append(accumulation)
      
# Compute average payout  
    totalPayout = 0
    for i in range(len(sequence)):
        totalPayout += 2^sequence[i]
    avg = float(totalPayout/nGames)
        
# Compute longest run of tails, max min, etc.    
    longestRun=max(sequence)
    longestRunIndex=sequence.index(longestRun)
    print('Luckiest: game # %s, first head at position %s, winning $%s.'%(longestRunIndex, longestRun, 2^longestRun))
    print('Lowest: %s'%min(daily))
    print('Highest: %s'%max(daily))
    print('Final: %s'%daily[nGames-1])
    print('Average payout:  %s.'%avg)

# Plot the money on hand.    
    l=list_plot(daily,plotjoined = True,gridlines=True)
    show(l)    #in interactive mode, the plot doesn't display with just the list_plot() command.
               #instead, we use the show() function.
︡da0a87e9-a889-4cbe-be4c-e946ad3b9653︡{"html": "<!--notruncate-->\n        <div padding=6 id=\"div-interact-5\">\n          <table width=800px height=20px bgcolor=\"#c5c5c5\" cellpadding=15>\n            <tr>\n              <td bgcolor=\"#f9f9f9\" valign=top align=left>\n            <table>\n              <tr><td colspan=3><table><tr><td align=right><font color=\"black\">price&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:inset;\" value=\"0\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(5, {variable: 'price', adapt_number: 13, value: encode64(this.value)}, 1)\">5</button>\n<button style=\"border-style:outset;\" value=\"1\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(5, {variable: 'price', adapt_number: 13, value: encode64(this.value)}, 1)\">10</button>\n<button style=\"border-style:outset;\" value=\"2\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(5, {variable: 'price', adapt_number: 13, value: encode64(this.value)}, 1)\">15</button>\n<button style=\"border-style:outset;\" value=\"3\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(5, {variable: 'price', adapt_number: 13, value: encode64(this.value)}, 1)\">20</button>\n</td></tr></table></td>\n</tr><tr><td align=right><font color=\"black\">nGames&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:inset;\" value=\"0\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(5, {variable: 'nGames', adapt_number: 14, value: encode64(this.value)}, 1)\">100</button>\n<button style=\"border-style:outset;\" value=\"1\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(5, {variable: 'nGames', adapt_number: 14, value: encode64(this.value)}, 1)\">1000</button>\n<button style=\"border-style:outset;\" value=\"2\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(5, {variable: 'nGames', adapt_number: 14, value: encode64(this.value)}, 1)\">10000</button>\n<button style=\"border-style:outset;\" value=\"3\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(5, {variable: 'nGames', adapt_number: 14, value: encode64(this.value)}, 1)\">100000</button>\n</td></tr></table></td>\n</tr></table></td></tr>\n              <tr><td></td><td style='width: 100%;'>\n        <div id=\"cell-interact-5\"><?__SAGE__START>\n          <table border=0 bgcolor=\"white\" width=100%>\n            <tr>\n              <td bgcolor=\"white\" align=left valign=top>\n                <pre><?__SAGE__TEXT></pre>\n              </td>\n            </tr>\n            <tr>\n              <td align=left valign=top><?__SAGE__HTML></td>\n            </tr>\n          </table><?__SAGE__END>\n        </div></td><td></td></tr>\n              <tr><td colspan=3></td></tr>\n            </table></td>\n            </tr>\n          </table>\n        </div>"}︡
